# Cavaliba / Field type USER

from .field import Field

from app_home.configuration import get_configuration

from app_user.models import SireneUser

from app_user.user import user_get_by_login

# -------------
# USER
# -------------
class FieldUser(Field):


    def get_attribute(self):
        ''' return list of SireneUser '''
        # self.value = ["a", "b", ..."]

        reply = []

        for login in self.value:
            userobj = user_get_by_login(login)
            reply.append(userobj)
        return reply


    def get_datapoint_ui_detail(self):

        datapoint = super().get_datapoint_ui_detail()

        datapoint["value"] = []
        # for i in self.value:
        #     if len(i) > 0:
        #         datapoint["value"].append(i)

        users = SireneUser.objects.filter(login__in=self.value, is_enabled=True)
        for i in users:
            item = { "key":i.login, "display":i.displayname }
            datapoint["value"].append(item)

        return datapoint        



    def get_datapoint_ui_edit(self):

        # value: [ { 'key':'keyname' , 'selected':True/False }, ...    ]

        datapoint = super().get_datapoint_ui_edit()

        datapoint["value"] = []
    
        # count = SireneUser.objects.count()
        # bigset_size = int(get_configuration("data","DATA_BIGSET_SIZE"))
        datapoint["bigset"] = True

        users = SireneUser.objects.filter(login__in=self.value, is_enabled=True)
        for i in users:
            selected = True
            item = { "key":i.login, "display":i.displayname, "selected":selected}
            datapoint["value"].append(item)



        return datapoint        


    def merge_edit_data(self, data):
        self.value = []
        for i in data:
            if len(i) > 0:
                self.value.append(i)

    def merge_new_data(self, data):
        self.value = []
        for i in data:
            if len(i) > 0:
                self.value.append(i)


    def is_valid(self):
        r = super().is_valid()
        # TODO
        return r